<?php

// IPplan v5.00a
// Aug 24, 2001
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
//

set_time_limit(0);

require_once("/usr/share/php/modules/adodb/adodb.inc.php");
require_once("../ipplanlib.php");
require_once("../config.php");

//Source DB
$dbf_type = "maxsql";
$dbf_host = "localhost";
$dbf_user = "ipplan";
$dbf_name = "ipplan";
$dbf_password = "ipplan99";


//Wanna print or let the script do all the work?
$print=FALSE;
//Something went wrong? Wanna do it again? Just skip what has been done
//set the value to 1 to skip
$tables = array( "grp" => 0, "users" => 0, "usergrp" => 0, "bounds" => 0,
               "customer" => 0, "custadd" => 0, "custinfo" => 0, "area" => 0,
               "netrange" => 0, "base" => 0, "baseadd" => 0, "ipaddr" => 0,
               "ipaddradd" => 0, "ipaddrlnk" => 0, "requestip" => 0, "revdns" => 0,
               "zones" => 0, "zonedns" => 0, "fwdzone" => 0, "fwdzoneadd" => 0,
               "fwddns" => 0, "fwdzonerec" => 0
             );

// always print for Oracle as there is no concept of a database
if ($dbf_type=="oci8po") {
	$print=TRUE;
}

//Source DB
$ds = &ADONewConnection($dbf_type);
if (!$ds) {
  die("Invalid database driver selected: ".$ds->ErrorMsg()."\n");
}
if(!$ds->Connect($dbf_host, $dbf_user, $dbf_password, $dbf_name)) {
  die("Failed to connect to the database: ".$ds->ErrorMsg()."\n");
}
$ds->SetFetchMode(2);

if (DBF_TYPE=="mssql" or DBF_TYPE=="ado_mssql" or DBF_TYPE=="odbc_mssql" or
       DBF_TYPE=='mysql' or DBF_TYPE=='maxsql') {
  $result=&$ds->Execute("SELECT version FROM version");
} else {
  $result=&$ds->Execute("SELECT version FROM schema");
}
$row = $result->FetchRow();
//If the version is not 22 then we can't migrate
if ( $row["version"] != 22 )
  die("You can only migrate if your schema version is 22. Yours are: ".$row["version"].". If you have 23 or higher there's no need to migrate\n");
$result->Close();


//Destination DB
$ds2 = &ADONewConnection(DBF_TYPE);
if (!$ds2) {
    die("Invalid database driver selected: ".$ds2->ErrorMsg()."\n");
}
if(!$ds2->NConnect(DBF_HOST, DBF_USER, DBF_PASSWORD, DBF_NAME)) {
    die("Failed to connect to the database: ".$ds2->ErrorMsg()."\n");
}
if ($dbf_type!="oci8po") {
    if (DBF_TYPE=="mssql" or DBF_TYPE=="ado_mssql" or DBF_TYPE=="odbc_mssql" or
            DBF_TYPE=='mysql' or DBF_TYPE=='maxsql') {
        $result=&$ds2->Execute("SELECT version FROM version");
    } else {
        $result=&$ds2->Execute("SELECT version FROM schema");
    }
    if (!$result)
        die("Error getting version. Make sure you have already installed IPPlan on your database\n");
    $row = $result->FetchRow();
    //If the destination version is >= 23 then no need to upgrade
    if (DBF_TYPE=="mssql" or DBF_TYPE=="ado_mssql" or DBF_TYPE=="odbc_mssql") {
        if ( $row[0] != 23 )
            die("Your version needs to be 23 for the migration. Older versions need to be upgrade to version 22. There is no need to migrate for versions greater than 23.\n");
    } else {
        if ( $row["version"] != 23 )
            die("Your version needs to be 23 for the migration. Older versions need to be upgrade to version 22. There is no need to migrate for versions greater than 23.\n");
    }
    $result->Close();
}

$ips = array ( 	"bounds"=>array("boundsaddr"),
		"area"=>array("areaaddr"),
		"netrange"=>array("rangeaddr"),
		"base"=>array("baseaddr"),
		"ipaddr"=>array("ipaddr"),
		"ipaddradd"=>array("ipaddr"),
		"ipaddrlnk"=>array("ipaddr","dstipaddr"),
		"revdns"=>array("ipaddr"),
		"zones"=>array("zoneip")
	     );
$size = array (	"bounds"=>array("boundssize"),
		"netrange"=>array("rangesize"),
		"base"=>array("subnetsize"),
		"zones"=>array("zonesize")
	      );
$quote = array( "grp"=>array("grpdescrip","grp","createcust"),
		"users"=>array("userid","userdescrip","useremail","password"),
		"usergrp"=>array("userid","grp"),
		"bounds"=>array("boundsaddr","grp"),
		"customer"=>array("custdescrip","crm","admingrp"),
		"custadd"=>array("info"),
		"custinfo"=>array("org","street","city","state","zipcode","cntry","maint",
"nichandl","lname","fname","mname","torg","tstreet","tcity","tstate","tzipcode",
"tcntry","phne","mbox"),
		"area"=>array("areaaddr","descrip"),
		"netrange"=>array("rangeaddr","descrip"),
		"base"=>array("baseaddr","descrip","admingrp","userid"),
		"baseadd"=>array("info"),
		"ipaddr"=>array("ipaddr","userinf","location","telno","descrip","hname","macaddr","userid"),
		"ipaddradd"=>array("ipaddr","info","infobin","infobinfn"),
		"ipaddrlnk"=>array("ipaddr","dstipaddr"),
		"requestip"=>array("requestdesc","userinf","location","telno","descrip","hname","macaddr","info"),
		"revdns"=>array("hname","ipaddr"),
		"zones"=>array("zoneip","zone","error_message","serialdate","userid","slaveonly","zonefilepath1","zonefilepath2","responsiblemail"),
		"zonedns"=>array("hname"),
		"fwdzone"=>array("domain","engineer","error_message","responsiblemail","serialdate","userid","slaveonly","zonefilepath1","zonefilepath2","admingrp"),
		"fwdzoneadd"=>array("info"),
		"fwddns"=>array("hname"),
		"fwdzonerec"=>array("host","recordtype","ip_hostname","error_message","userid")
		
	      );
$time = array(	"base"=>array("lastmod","swipmod"),
		"ipaddr"=>array("lastmod","lastpol"),
		"requestip"=>array("lastmod"),
		"zones"=>array("lastmod","lastexp"),
		"fwdzone"=>array("createmod","lastmod","regmod","expiremod","lastexp"),
		"fwdzonerec"=>array("lastmod")
	     );

$triggers = array( "grp" => 0, "users" => 0, "usergrp" => 0, "bounds" => 0,
               "customer" => 1, "custadd" => 0, "custinfo" => 0, "area" => 1,
               "netrange" => 1, "base" => 1, "baseadd" => 0, "ipaddr" => 0,
               "ipaddradd" => 0, "ipaddrlnk" => 0, "requestip" => 1, "revdns" => 0,
               "zones" => 1, "zonedns" => 0, "fwdzone" => 1, "fwdzoneadd" => 0,
               "fwddns" => 0, "fwdzonerec" => 1
             );


foreach ($tables as $table=>$skip) {
    if ($skip) continue;
    if (DBF_TYPE=="mssql" or DBF_TYPE=="ado_mssql" or DBF_TYPE=="odbc_mssql") {
        $q="SET IDENTITY_INSERT $table ON";
        if ( $print ) {
            print "$q;\n";
        } else {
            $ds2->Execute($q);
        }
    }
    if (DBF_TYPE=="oci8po" and $triggers[$table]==1) {
        $q="ALTER TRIGGER TRIG_SEQ_$table DISABLE";
        if ( $print ) {
            print "$q;\n";
        } else {
            $ds2->Execute($q);
        }
    }
    if (!$print) {
        print "Migrating table $table\n";
        $ds2->BeginTrans();
    }
    DoSql($table,$print);
    if (!$print)
        $ds2->CommitTrans();
    if (DBF_TYPE=="mssql" or DBF_TYPE=="ado_mssql" or DBF_TYPE=="odbc_mssql") {
        $q="SET IDENTITY_INSERT $table OFF";
        if ( $print ) {
            print "$q;\n";
        } else {
            $ds2->Execute($q);
        }
    }
    if (DBF_TYPE=="oci8po" and $triggers[$table]==1) {
        $q="ALTER TRIGGER TRIG_SEQ_$table ENABLE";
        if ( $print ) {
            print "$q;\n";
        } else {
            $ds2->Execute($q);
        }
    }
}

function DoSql ($table, $print) {
    global $ds, $ds2, $quote, $time,$ips,$size;

    $do_ips = array_key_exists($table,$ips);
    $do_size = array_key_exists($table,$size);
    $do_quote = array_key_exists($table,$quote);
    $do_time = array_key_exists($table,$time);

    // tables that require a group by to reduce memory requirement during migration
    // array key is table and value is database field to GROUP BY
    $tablegrpby["ipaddr"]="baseindex";
    $tablegrpby["ipaddradd"]="baseindex";
    $tablegrpby["base"]="customer";

    $nogrpby=TRUE;
    if (array_key_exists($table, $tablegrpby)) {
        $grpby=$tablegrpby[$table];
        $resultg = &$ds->Execute("SELECT $grpby FROM $table GROUP BY $grpby");
        $nogrpby=FALSE;
    }
    while ( $nogrpby or $rowg = $resultg->FetchRow() ) {
        $where="";
        if(!$nogrpby) {
            $where=" WHERE $grpby=".$rowg[$grpby];
        }
        $result = &$ds->Execute("SELECT * FROM $table".$where);
        while ( $row = $result->FetchRow() ) {
            if ($do_ips) {
                foreach ($ips[$table] as $ips_field)
                    $row[$ips_field] = inet_ntoa($row[$ips_field]);
            }
            if ($do_size) {
                foreach ($size[$table] as $size_field)
                    $row[$size_field] = inet_bits($row[$size_field]);
            }
            if ($do_quote) {
                foreach ($quote[$table] as $quote_field)
                    $row[$quote_field] = $ds2->qstr($row[$quote_field]);
            }
            if ($do_time) {
                foreach ($time[$table] as $time_field)
                    $row[$time_field] = $ds2->DBTimeStamp($row[$time_field]);
            }

            //str_replace(NULL, "NULL", $row); // does not work as expected
            //var_dump($row);
            foreach ($row as $key => $value) { 
                if ($value===NULL) 
                    $row[$key]="NULL";
            }
            //var_dump($row);

            $q = "INSERT INTO $table (".implode(", ",array_keys($row)).") VALUES (".implode(", ",$row).")";
            if ( $print ) {
                print "$q;\n";
            } else {
                $success = $ds2->Execute($q);
                if ( !$success ) {
                    die("Failed to execute the following query: $q\n");
                    $ds2->RollBackTrans();
                }
            }
        }
        if($nogrpby) {      // no group by for this table, only loop once
            break;
        }
    }
}

?>
