<?php

require_once("../config.php");

$tables['area']=array(
   array('areaaddr', 'C', '39', 'DEFAULT' => '', 'NotNull'),
   array('descrip', 'C', '80', 'DEFAULT' => '', 'NotNull'),
   array('areaindex',  'I8', 'AUTOINCREMENT', 'NotNull', 'PRIMARY'),
   array('customer', (DBF_TYPE=='mysql' or DBF_TYPE=='maxsql') ? 'SMALLINT UNSIGNED':'I4', 'DEFAULT' => 0, 'NotNull')
);
$indexes['area']=array(
   array('area_customer', 'customer,descrip', array('UNIQUE')),
   array('area_areaaddr', 'areaaddr,customer', array('UNIQUE'))
);

$tables['auditlog']=array(
   array('userid', 'C', '40', 'DEFAULT' => ''),
   array('action', 'C', '254', 'DEFAULT' => '', 'NotNull'),
   array('dt', 'T', 'DEFTIMESTAMP', 'NotNull'),
);
$indexes['auditlog']=array(
   array('auditlog_dt', 'dt')
);

$tables['base']=array(
   array('baseaddr', 'C', '39', 'DEFAULT' => '', 'NotNull'),
   array('subnetsize', (DBF_TYPE=='mysql' or DBF_TYPE=='maxsql') ? 'INT UNSIGNED':'I8', 'DEFAULT' => 0, 'NotNull'),
   array('descrip', 'C', '80', 'DEFAULT' => '', 'NotNull'),
   array('baseindex',  'I8', 'AUTOINCREMENT', 'NotNull', 'PRIMARY'),
   array('admingrp', 'C', '40', 'DEFAULT' => '', 'NotNull'),
   array('customer', (DBF_TYPE=='mysql' or DBF_TYPE=='maxsql') ? 'SMALLINT UNSIGNED':'I4', 'DEFAULT' => 0, 'NotNull'),
   array('lastmod', 'T', 'DEFTIMESTAMP', 'NotNull'),
   array('userid', 'C', '40', 'DEFAULT' => ''),
   // baseopt is a binary encoded field - bit 0 defines if the subnet is DHCP if set
   array('baseopt', (DBF_TYPE=='mysql' or DBF_TYPE=='maxsql') ? 'INT UNSIGNED':'I8', 'DEFAULT' => 0),
   array('swipmod', 'T', 'Null')
);
$indexes['base']=array(
   array('base_baseaddr', 'baseaddr,customer', array('UNIQUE')),
   array('base_customer', 'customer'),
   array('base_admingrp', 'admingrp')
);

$tables['baseadd']=array(
   array('baseindex', 'I8', 'DEFAULT' => 0, 'NotNull', 'PRIMARY'),
   array('info', 'X', 'DEFAULT' => ''),
   array('infobin', (DBF_TYPE=='oci8po') ? 'XL':'B', 'DEFAULT' => '', 'Null'),
   array('infobinfn', 'C', '255', 'DEFAULT' => '', 'Null')
);

$tables['custinfo']=array(
   array('customer', (DBF_TYPE=='mysql' or DBF_TYPE=='maxsql') ? 'SMALLINT UNSIGNED':'I4', 'DEFAULT' => 0, 'NotNull', 'PRIMARY'),
   array('org', 'C', '100', 'DEFAULT' => ''),
   array('street', 'C', '255', 'DEFAULT' => ''),
   array('city', 'C', '80', 'DEFAULT' => ''),
   array('state', 'C', '2', 'DEFAULT' => ''),
   array('zipcode', 'C', '10', 'DEFAULT' => ''),
   array('cntry', 'C', '2', 'DEFAULT' => ''),
   array('maint', 'C', '80', 'DEFAULT' => ''),
   array('nichandl', 'C', '80', 'DEFAULT' => ''),
   array('lname', 'C', '80', 'DEFAULT' => ''),
   array('fname', 'C', '80', 'DEFAULT' => ''),
   array('mname', 'C', '80', 'DEFAULT' => ''),
   array('torg', 'C', '100', 'DEFAULT' => ''),
   array('tstreet', 'C', '255', 'DEFAULT' => ''),
   array('tcity', 'C', '80', 'DEFAULT' => ''),
   array('tstate', 'C', '2', 'DEFAULT' => ''),
   array('tzipcode', 'C', '10', 'DEFAULT' => ''),
   array('tcntry', 'C', '2', 'DEFAULT' => ''),
   array('phne', 'C', '20', 'DEFAULT' => ''),
   array('mbox', 'C', '100', 'DEFAULT' => '')
);

$tables['custadd']=array(
   array('customer', (DBF_TYPE=='mysql' or DBF_TYPE=='maxsql') ? 'SMALLINT UNSIGNED':'I4', 'DEFAULT' => 0, 'NotNull', 'PRIMARY'),
   array('info', 'X', 'DEFAULT' => ''),
   array('infobinfn', 'C', '255', 'DEFAULT' => '', 'Null')
);

$tables['customer']=array(
   array('custdescrip', 'C', '80', 'DEFAULT' => '', 'NotNull'),
   array('customer', (DBF_TYPE=='mysql' or DBF_TYPE=='maxsql') ? 'SMALLINT UNSIGNED':'I4', 'AUTOINCREMENT', 'NotNull', 'PRIMARY'),
   array('crm', 'C', '20', 'DEFAULT' => ''),
   array('admingrp', 'C', '40', 'DEFAULT' => '', 'NotNull')
);
$indexes['customer']=array(
   array('customer_custdescrip', 'custdescrip', array('UNIQUE')),
   array('customer_crm', 'crm'),
   array('customer_admingrp', 'admingrp')
);

$tables['grp']=array(
   array('grpdescrip', 'C', '80', 'DEFAULT' => '', 'NotNull'),
   array('grp', 'C', '40', 'DEFAULT' => '', 'NotNull', 'PRIMARY'),
   array('createcust', 'C', '1', 'DEFAULT' => 'N', 'NotNull'),
   array('resaddr', (DBF_TYPE=='mysql' or DBF_TYPE=='maxsql') ? 'SMALLINT UNSIGNED':'I4', 'DEFAULT' => 0),
   array('grpopt', (DBF_TYPE=='mysql' or DBF_TYPE=='maxsql') ? 'INT UNSIGNED':'I8', 'DEFAULT' => 0, 'NotNull')
);
$indexes['grp']=array(
   array('grp_grpdescrip', 'grpdescrip', array('UNIQUE'))
);

// order of columns for PRIMARY KEY is important!!
$tables['ipaddr']=array(
   array('ipaddr', 'C', '39', 'DEFAULT' => '', 'NotNull', 'PRIMARY'),
   array('userinf', 'C', '80', 'DEFAULT' => ''),
   array('location', 'C', '80', 'DEFAULT' => ''),
   array('telno', 'C', '15', 'DEFAULT' => ''),
   array('descrip', 'C', '80', 'DEFAULT' => ''),
   array('hname', 'C', '100', 'DEFAULT' => ''),
   array('macaddr', 'C', '12', 'DEFAULT' => ''),
   array('baseindex', 'I8', 'DEFAULT' => 0, 'NotNull', 'PRIMARY'),
   array('lastmod', 'T', 'DEFTIMESTAMP', 'NotNull'),
   array('lastpol', 'T'),
   array('userid', 'C', '40', 'DEFAULT' => '')
);
$indexes['ipaddr']=array(
   array('ipaddr_baseindex', 'baseindex')
);

// order of columns for PRIMARY KEY is important!!
$tables['ipaddradd']=array(
   array('ipaddr', 'C', '39', 'DEFAULT' => '', 'NotNull', 'PRIMARY'),
   array('baseindex', 'I8', 'DEFAULT' => 0, 'NotNull', 'PRIMARY'),
   array('info', 'X', 'DEFAULT' => ''),
   array('infobin', (DBF_TYPE=='oci8po') ? 'XL':'B', 'DEFAULT' => '', 'Null'),
   array('infobinfn', 'C', '255', 'DEFAULT' => '', 'Null')
);
$indexes['ipaddradd']=array(
   array('ipaddradd_baseindex', 'baseindex')
);

$tables['ipaddrlnk']=array(
   array('ipaddr', 'C', '39', 'DEFAULT' => '', 'NotNull'),
   array('baseindex', 'I8', 'DEFAULT' => 0, 'NotNull'),
   array('customer', (DBF_TYPE=='mysql' or DBF_TYPE=='maxsql') ? 'SMALLINT UNSIGNED':'I4', 'DEFAULT' => 0, 'NotNull'),
   array('dstipaddr', 'C', '39', 'DEFAULT' => '', 'NotNull'),
   array('dstcustomer', (DBF_TYPE=='mysql' or DBF_TYPE=='maxsql') ? 'SMALLINT UNSIGNED':'I4', 'DEFAULT' => 0, 'NotNull')
);
$indexes['ipaddrlnk']=array(
   array('ipaddrlnk_uniq', 'baseindex, ipaddr, customer, dstipaddr, dstcustomer', array('UNIQUE')),
   array('ipaddrlnk_dst', 'dstipaddr, dstcustomer'),
   array('ipaddrlnk_src', 'ipaddr, customer')
);

$tables['requestip']=array(
   array('requestindex', 'I4', 'AUTOINCREMENT', 'NotNull', 'PRIMARY'),
   array('customer', (DBF_TYPE=='mysql' or DBF_TYPE=='maxsql') ? 'SMALLINT UNSIGNED':'I4', 'DEFAULT' => 0, 'NotNull'),
   array('requestdesc', 'C', '80', 'DEFAULT' => ''),
   array('userinf', 'C', '80', 'DEFAULT' => ''),
   array('location', 'C', '80', 'DEFAULT' => ''),
   array('telno', 'C', '15', 'DEFAULT' => ''),
   array('descrip', 'C', '80', 'DEFAULT' => ''),
   array('hname', 'C', '100', 'DEFAULT' => ''),
   array('macaddr', 'C', '12', 'DEFAULT' => ''),
   array('lastmod', 'T', 'DEFTIMESTAMP', 'NotNull'),
   array('info', 'X', 'DEFAULT' => '')
);
$indexes['requestip']=array(
   array('requestip_desc', 'customer, requestdesc', array('UNIQUE'))
);

$tables['netrange']=array(
   array('rangeaddr', 'C', '39', 'DEFAULT' => '', 'NotNull'),
   array('rangesize', (DBF_TYPE=='mysql' or DBF_TYPE=='maxsql') ? 'INT UNSIGNED':'I8', 'DEFAULT' => 0, 'NotNull'),
   array('descrip', 'C', '80', 'DEFAULT' => '', 'NotNull'),
   array('rangeindex',  'I8', 'AUTOINCREMENT', 'NotNull', 'PRIMARY'),
   array('areaindex',  'I8', 'DEFAULT' => 0, 'NotNull'),
   array('customer', (DBF_TYPE=='mysql' or DBF_TYPE=='maxsql') ? 'SMALLINT UNSIGNED':'I4', 'DEFAULT' => 0, 'NotNull')
);
$indexes['netrange']=array(

//   array('range_rangeaddr', 'rangeaddr,customer', array('UNIQUE')),
   array('range_rangeaddr', 'rangeaddr,customer'),
   array('range_customer', 'customer,descrip', array('UNIQUE')),
   array('range_areaindex', 'areaindex')
);

$tables['revdns']=array(
   array('customer', (DBF_TYPE=='mysql' or DBF_TYPE=='maxsql') ? 'SMALLINT UNSIGNED':'I4', 'DEFAULT' => 0, 'NotNull'),
   array('hname', 'C', '100', 'DEFAULT' => '', 'NotNull'),
   array('ipaddr', 'C', '39', 'DEFAULT' => '', 'NotNull'),
   array('horder', (DBF_TYPE=='mysql' or DBF_TYPE=='maxsql') ? 'TINYINT UNSIGNED':'I1', 'DEFAULT' => 0, 'NotNull')
);
$indexes['revdns']=array(
   array('revdns_customer', 'customer')
);

if (DBF_TYPE=="mssql" or DBF_TYPE=="ado_mssql" or DBF_TYPE=="odbc_mssql" or
    DBF_TYPE=='mysql' or DBF_TYPE=='maxsql') {
   $tables['version']=array(
      array('version', 'I4', 'DEFAULT' => 0, 'NotNull')
   );
}
else {
   $tables['schema']=array(
      array('version', 'I4', 'DEFAULT' => 0, 'NotNull')
   );
}

$tables['users']=array(
   array('userid', 'C', '40', 'DEFAULT' => '', 'NotNull', 'PRIMARY'),
   array('userdescrip', 'C', '80', 'DEFAULT' => '', 'NotNull'),
   array('useremail', 'C', '64', 'DEFAULT' => '', 'Null'),
   array('password', 'C', '40', 'DEFAULT' => '', 'NotNull')
);

$tables['usergrp']=array(
   array('userid', 'C', '40', 'DEFAULT' => '', 'NotNull'),
   array('grp', 'C', '40', 'DEFAULT' => '', 'NotNull')
);
$indexes['usergrp']=array(
   array('usergrp_userid', 'userid,grp', array('UNIQUE')),
   array('usergrp_grp', 'grp')
);

$tables['bounds']=array(
   array('boundsaddr', 'C', '39', 'DEFAULT' => '', 'NotNull'),
   array('boundssize', (DBF_TYPE=='mysql' or DBF_TYPE=='maxsql') ? 'INT UNSIGNED':'I8', 'DEFAULT' => 0, 'NotNull'),
   array('grp', 'C', '40', 'DEFAULT' => '', 'NotNull')
);
$indexes['bounds']=array(
   array('bounds_grp', 'grp'),
   array('bounds_boundsaddr', 'boundsaddr')
);

$tables['fwdzone']=array(
   array('data_id', 'I8', 'AUTOINCREMENT', 'NotNull', 'PRIMARY'),
   array('domain', 'C', '254', 'DEFAULT' => '', 'NotNull'),
   array('createmod', 'D', 'DEFAULT' => '', 'Null'),
   array('lastmod', 'T', 'DEFAULT' => '', 'Null'),
   array('regmod', 'D', 'DEFAULT' => '', 'Null'),
   array('expiremod', 'T', 'DEFAULT' => '', 'Null'),
   array('engineer', 'C', '254', 'DEFAULT' => '', 'Null'),
   array('error_message', 'C', '254', 'DEFAULT' => '', 'Null'),
   array('responsiblemail', 'C', '64', 'DEFAULT' => '', 'Null'),
   array('serialdate', 'C', '8', 'DEFAULT' => '', 'NotNull'),
   array('serialnum', 'I4', 'DEFAULT' => 0),
   array('ttl', 'I4', 'DEFAULT' => 0),
   array('refresh', 'I4', 'DEFAULT' => 0),
   array('retry', 'I4', 'DEFAULT' => 0),
   array('expire', 'I4', 'DEFAULT' => 0),
   array('minimum', 'I4', 'DEFAULT' => 0),
   array('userid', 'C', '40', 'DEFAULT' => ''),
   array('lastexp', 'T', 'DEFAULT' => '', 'Null'),
   array('slaveonly', 'C', '1', 'DEFAULT' => 'N', 'NotNull'),
   array('zonefilepath1', 'C', '254', 'DEFAULT' => '', 'Null'),
   array('zonefilepath2', 'C', '254', 'DEFAULT' => '', 'Null'),
   array('customer', (DBF_TYPE=='mysql' or DBF_TYPE=='maxsql') ? 'SMALLINT UNSIGNED':'I4', 'DEFAULT' => 0, 'NotNull'),
   array('admingrp', 'C', '40', 'DEFAULT' => '', 'Null')
);
$indexes['fwdzone']=array(
   array('fwdzone_customer', 'customer'),
   array('fwdzone_domain', 'domain')
);

$tables['fwdzoneadd']=array(
   array('customer', (DBF_TYPE=='mysql' or DBF_TYPE=='maxsql') ? 'SMALLINT UNSIGNED':'I4', 'DEFAULT' => 0, 'NotNull'),
   array('data_id', 'I8', 'DEFAULT' => 0, 'NotNull'),
   array('info', 'X', 'DEFAULT' => ''),
   array('infobinfn', 'C', '255', 'DEFAULT' => '', 'Null')
);
$indexes['fwdzoneadd']=array(
   array('fwdzoneadd_customer', 'customer,data_id', array('UNIQUE'))
);

$tables['fwdzonerec']=array(
   array('recidx', 'I8', 'AUTOINCREMENT', 'NotNull', 'PRIMARY'),
   array('data_id', 'I8', 'DEFAULT' => 0, 'NotNull'),
   array('lastmod', 'T', 'DEFAULT' => '', 'Null'),
   array('host', 'C', '254', 'DEFAULT' => '', 'NotNull'),
   array('recordtype', 'C', '5', 'DEFAULT' => '', 'NotNull'),
   array('ip_hostname', 'C', '254', 'DEFAULT' => '', 'NotNull'),
   array('error_message', 'C', '254', 'DEFAULT' => '', 'Null'),
   array('sortorder', 'I4', 'DEFAULT' => 0, 'NotNull'),
   array('userid', 'C', '40', 'DEFAULT' => '', 'NotNull'),
   array('customer', (DBF_TYPE=='mysql' or DBF_TYPE=='maxsql') ? 'SMALLINT UNSIGNED':'I4', 'DEFAULT' => 0, 'NotNull')
);
$indexes['fwdzonerec']=array(
   array('fwdzonerec_data_id', 'data_id'),
   array('fwdzonerec_sortorder', 'sortorder'),
   array('fwdzonerec_customer', 'customer')
);

$tables['fwddns']=array(
   array('id', 'I8', 'DEFAULT' => 0, 'NotNull'),
   array('hname', 'C', '100', 'DEFAULT' => '', 'NotNull'),
   array('horder', (DBF_TYPE=='mysql' or DBF_TYPE=='maxsql') ? 'TINYINT UNSIGNED':'I1', 'DEFAULT' => 0, 'NotNull')
);
$indexes['fwddns']=array(
   array('fwddns_id', 'id')
);

$tables['zones']=array(
   array('id', 'I8', 'AUTOINCREMENT', 'NotNull', 'PRIMARY'),
   array('zoneip', 'C', '39', 'DEFAULT' => '', 'NotNull'),
   array('zonesize', (DBF_TYPE=='mysql' or DBF_TYPE=='maxsql') ? 'INT UNSIGNED':'I8', 'DEFAULT' => 0, 'NotNull'),
   array('zone', 'C', '254', 'DEFAULT' => '', 'NotNull'),
   array('error_message', 'C', '254', 'DEFAULT' => '', 'Null'),
   array('lastmod', 'T', 'DEFAULT' => '', 'Null'),
   array('serialdate', 'C', '8', 'DEFAULT' => '', 'NotNull'),
   array('serialnum', 'I4', 'DEFAULT' => 0),
   array('ttl', 'I4', 'DEFAULT' => 0),
   array('refresh', 'I4', 'DEFAULT' => 0),
   array('retry', 'I4', 'DEFAULT' => 0),
   array('expire', 'I4', 'DEFAULT' => 0),
   array('minimum', 'I4', 'DEFAULT' => 0),
   array('userid', 'C', '40', 'DEFAULT' => ''),
   array('lastexp', 'T', 'DEFAULT' => '', 'Null'),
   array('slaveonly', 'C', '1', 'DEFAULT' => 'N', 'NotNull'),
   array('zonefilepath1', 'C', '254', 'DEFAULT' => '', 'Null'),
   array('zonefilepath2', 'C', '254', 'DEFAULT' => '', 'Null'),
   array('responsiblemail', 'C', '64', 'DEFAULT' => '', 'Null'),
   array('customer', (DBF_TYPE=='mysql' or DBF_TYPE=='maxsql') ? 'SMALLINT UNSIGNED':'I4', 'DEFAULT' => 0, 'NotNull')
);
$indexes['zones']=array(
   array('zones_customer', 'customer'),
   array('zones_zoneip', 'zoneip')
);

$tables['zonedns']=array(
   array('id', 'I8', 'DEFAULT' => 0, 'NotNull'),
   array('hname', 'C', '100', 'DEFAULT' => '', 'NotNull'),
   array('horder', (DBF_TYPE=='mysql' or DBF_TYPE=='maxsql') ? 'TINYINT UNSIGNED':'I1', 'DEFAULT' => 0, 'NotNull')
);
$indexes['zonedns']=array(
   array('zonedns_id', 'id')
);

?>