<?php

// IPplan v6.00-BETA2
// Aug 24, 2001
//
// Modified by Frank Elsner [FE], June 2005

// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
//

function getNetmask ($mask) {
  $arr = array("128.0.0.0"=>1,
			  "192.0.0.0"=>2,
			  "224.0.0.0"=>3,
			  "240.0.0.0"=>4,
			  "248.0.0.0"=>5,
			  "252.0.0.0"=>6,
			  "254.0.0.0"=>7,
			  "255.0.0.0"=>8,
			  "255.128.0.0"=>9,
			  "255.192.0.0"=>10,
			  "255.224.0.0"=>11,
			  "255.240.0.0"=>12,
			  "255.248.0.0"=>13,
			  "255.252.0.0"=>14,
			  "255.254.0.0"=>15,
			  "255.255.0.0"=>16,
			  "255.255.128.0"=>17,
			  "255.255.192.0"=>18,
			  "255.255.224.0"=>19,
			  "255.255.240.0"=>20,
			  "255.255.248.0"=>21,
			  "255.255.252.0"=>22,
			  "255.255.254.0"=>23,
			  "255.255.255.0"=>24,
			  "255.255.255.128"=>25,
			  "255.255.255.192"=>26,
			  "255.255.255.224"=>27,
			  "255.255.255.240"=>28,
			  "255.255.255.248"=>29,
			  "255.255.255.252"=>30,
			  "255.255.255.254"=>31,
			  "255.255.255.255"=>32,
			  "8000::"=>1,
			  "c000::"=>2,
			  "e000::"=>3,
			  "f000::"=>4,
			  "f800::"=>5,
			  "fc00::"=>6,
			  "fe00::"=>7,
			  "ff00::"=>8,
			  "ff80::"=>9,
			  "ffc0::"=>10,
			  "ffe0::"=>11,
			  "fff0::"=>12,
			  "fff8::"=>13,
			  "fffc::"=>14,
			  "fffe::"=>15,
			  "ffff::"=>16,
			  "ffff:8000::"=>17,
			  "ffff:c000::"=>18,
			  "ffff:e000::"=>19,
			  "ffff:f000::"=>20,
			  "ffff:f800::"=>21,
			  "ffff:fc00::"=>22,
			  "ffff:fe00::"=>23,
			  "ffff:ff00::"=>24,
			  "ffff:ff80::"=>25,
			  "ffff:ffc0::"=>26,
			  "ffff:ffe0::"=>27,
			  "ffff:fff0::"=>28,
			  "ffff:fff8::"=>29,
			  "ffff:fffc::"=>30,
			  "ffff:fffe::"=>31,
			  "ffff:ffff::"=>32,
			  "ffff:ffff:8000::"=>33,
			  "ffff:ffff:c000::"=>34,
			  "ffff:ffff:e000::"=>35,
			  "ffff:ffff:f000::"=>36,
			  "ffff:ffff:f800::"=>37,
			  "ffff:ffff:fc00::"=>38,
			  "ffff:ffff:fe00::"=>39,
			  "ffff:ffff:ff00::"=>40,
			  "ffff:ffff:ff80::"=>41,
			  "ffff:ffff:ffc0::"=>42,
			  "ffff:ffff:ffe0::"=>43,
			  "ffff:ffff:fff0::"=>44,
			  "ffff:ffff:fff8::"=>45,
			  "ffff:ffff:fffc::"=>46,
			  "ffff:ffff:fffe::"=>47,
			  "ffff:ffff:ffff::"=>48,
			  "ffff:ffff:ffff:8000::"=>49,
			  "ffff:ffff:ffff:c000::"=>50,
			  "ffff:ffff:ffff:e000::"=>51,
			  "ffff:ffff:ffff:f000::"=>52,
			  "ffff:ffff:ffff:f800::"=>53,
			  "ffff:ffff:ffff:fc00::"=>54,
			  "ffff:ffff:ffff:fe00::"=>55,
			  "ffff:ffff:ffff:ff00::"=>56,
			  "ffff:ffff:ffff:ff80::"=>57,
			  "ffff:ffff:ffff:ffc0::"=>58,
			  "ffff:ffff:ffff:ffe0::"=>59,
			  "ffff:ffff:ffff:fff0::"=>60,
			  "ffff:ffff:ffff:fff8::"=>61,
			  "ffff:ffff:ffff:fffc::"=>62,
			  "ffff:ffff:ffff:fffe::"=>63,
			  "ffff:ffff:ffff:ffff::"=>64,
			  "ffff:ffff:ffff:ffff:8000::"=>65,
			  "ffff:ffff:ffff:ffff:c000::"=>66,
			  "ffff:ffff:ffff:ffff:e000::"=>67,
			  "ffff:ffff:ffff:ffff:f000::"=>68,
			  "ffff:ffff:ffff:ffff:f800::"=>69,
			  "ffff:ffff:ffff:ffff:fc00::"=>70,
			  "ffff:ffff:ffff:ffff:fe00::"=>71,
			  "ffff:ffff:ffff:ffff:ff00::"=>72,
			  "ffff:ffff:ffff:ffff:ff80::"=>73,
			  "ffff:ffff:ffff:ffff:ffc0::"=>74,
			  "ffff:ffff:ffff:ffff:ffe0::"=>75,
			  "ffff:ffff:ffff:ffff:fff0::"=>76,
			  "ffff:ffff:ffff:ffff:fff8::"=>77,
			  "ffff:ffff:ffff:ffff:fffc::"=>78,
			  "ffff:ffff:ffff:ffff:fffe::"=>79,
			  "ffff:ffff:ffff:ffff:ffff::"=>80,
			  "ffff:ffff:ffff:ffff:ffff:8000::"=>81,
			  "ffff:ffff:ffff:ffff:ffff:c000::"=>82,
			  "ffff:ffff:ffff:ffff:ffff:e000::"=>83,
			  "ffff:ffff:ffff:ffff:ffff:f000::"=>84,
			  "ffff:ffff:ffff:ffff:ffff:f800::"=>85,
			  "ffff:ffff:ffff:ffff:ffff:fc00::"=>86,
			  "ffff:ffff:ffff:ffff:ffff:fe00::"=>87,
			  "ffff:ffff:ffff:ffff:ffff:ff00::"=>88,
			  "ffff:ffff:ffff:ffff:ffff:ff80::"=>89,
			  "ffff:ffff:ffff:ffff:ffff:ffc0::"=>90,
			  "ffff:ffff:ffff:ffff:ffff:ffe0::"=>91,
			  "ffff:ffff:ffff:ffff:ffff:fff0::"=>92,
			  "ffff:ffff:ffff:ffff:ffff:fff8::"=>93,
			  "ffff:ffff:ffff:ffff:ffff:fffc::"=>94,
			  "ffff:ffff:ffff:ffff:ffff:fffe::"=>95,
			  "ffff:ffff:ffff:ffff:ffff:ffff::"=>96,
			  "ffff:ffff:ffff:ffff:ffff:ffff:8000::"=>97,
			  "ffff:ffff:ffff:ffff:ffff:ffff:c000::"=>98,
			  "ffff:ffff:ffff:ffff:ffff:ffff:e000::"=>99,
			  "ffff:ffff:ffff:ffff:ffff:ffff:f000::"=>100,
			  "ffff:ffff:ffff:ffff:ffff:ffff:f800::"=>101,
			  "ffff:ffff:ffff:ffff:ffff:ffff:fc00::"=>102,
			  "ffff:ffff:ffff:ffff:ffff:ffff:fe00::"=>103,
			  "ffff:ffff:ffff:ffff:ffff:ffff:ff00::"=>104,
			  "ffff:ffff:ffff:ffff:ffff:ffff:ff80::"=>105,
			  "ffff:ffff:ffff:ffff:ffff:ffff:ffc0::"=>106,
			  "ffff:ffff:ffff:ffff:ffff:ffff:ffe0::"=>107,
			  "ffff:ffff:ffff:ffff:ffff:ffff:fff0::"=>108,
			  "ffff:ffff:ffff:ffff:ffff:ffff:fff8::"=>109,
			  "ffff:ffff:ffff:ffff:ffff:ffff:fffc::"=>110,
			  "ffff:ffff:ffff:ffff:ffff:ffff:fffe::"=>111,
			  "ffff:ffff:ffff:ffff:ffff:ffff:ffff::"=>112,
			  "ffff:ffff:ffff:ffff:ffff:ffff:ffff:8000"=>113,
			  "ffff:ffff:ffff:ffff:ffff:ffff:ffff:c000"=>114,
			  "ffff:ffff:ffff:ffff:ffff:ffff:ffff:e000"=>115,
			  "ffff:ffff:ffff:ffff:ffff:ffff:ffff:f000"=>116,
			  "ffff:ffff:ffff:ffff:ffff:ffff:ffff:f800"=>117,
			  "ffff:ffff:ffff:ffff:ffff:ffff:ffff:fc00"=>118,
			  "ffff:ffff:ffff:ffff:ffff:ffff:ffff:fe00"=>119,
			  "ffff:ffff:ffff:ffff:ffff:ffff:ffff:ff00"=>120,
			  "ffff:ffff:ffff:ffff:ffff:ffff:ffff:ff80"=>121,
			  "ffff:ffff:ffff:ffff:ffff:ffff:ffff:ffc0"=>122,
			  "ffff:ffff:ffff:ffff:ffff:ffff:ffff:ffe0"=>123,
			  "ffff:ffff:ffff:ffff:ffff:ffff:ffff:fff0"=>124,
			  "ffff:ffff:ffff:ffff:ffff:ffff:ffff:fff8"=>125,
			  "ffff:ffff:ffff:ffff:ffff:ffff:ffff:fffc"=>126,
			  "ffff:ffff:ffff:ffff:ffff:ffff:ffff:fffe"=>127,
			  "ffff:ffff:ffff:ffff:ffff:ffff:ffff:ffff"=>128);

   foreach ($arr as $key => $value) {
      if ( $key==$mask )
         return $value;
   }

   return 0;

}

require_once("../ipplanlib.php");
require_once("/usr/share/php/modules/adodb/adodb.inc.php");
require_once("../class.dbflib.php");
require_once("../class.templib.php");
require_once("../layout/class.layout");
require_once("../auth.php");

$auth = new BasicAuthenticator(ADMINREALM, REALMERROR);

$auth->addUser(ADMINUSER, ADMINPASSWD);

// And now perform the authentication
$auth->authenticate();

// save the last customer used
// must set path else Netscape gets confused!
setcookie("ipplanCustomer","$cust",time() + 10000000, "/");

// set language
isset($_COOKIE["ipplanLanguage"]) && myLanguage($_COOKIE['ipplanLanguage']);

//setdefault("window",array("bgcolor"=>"white"));
//setdefault("table",array("cellpadding"=>"0"));
//setdefault("text",array("size"=>"2"));

$title=my_("Import subnet results");
newhtml($p);
$w=myheading($p, $title);

// explicitly cast variables as security measure against SQL injection
list($cust, $admingrp) = myRegister("I:cust S:admingrp");

if (empty($_FILES)) {
   $tmp=get_cfg_var("file_uploads");
   if (empty($tmp)) {
      insert($w,block("<b>".my_("File uploads may have been disabled in the php.ini configuration file")."</b><p>"));
   }
}
else {
   if ($_FILES['userfile']['size'] == 0) {
      myError($w,$p, my_("Possible file size exceeded php.ini or webserver limit of 2meg - break file into smaller parts"));
   }
   if (!is_uploaded_file($_FILES['userfile']['tmp_name'])) {
      myError($w,$p, my_("Possible file upload attack"));
   }
}
$filename = $_FILES['userfile']['tmp_name'];

// basic sequence is connect, search, interpret search
// result, close connection

$ds=new IPplanDbf() or myError($w,$p, my_("Could not connect to database"));

// open uploaded file for read
$fp = @fopen ($filename, "r");
if (!$fp) {
   myError($w,$p, my_("File could not be opened."));
}

// Changed - Begin [FE]
// Start of template support for base.

// can we read the template?
$template=new IPplanIPTemplate("basetemplate", $cust);
if ($template->is_error() == TRUE) {
    myError($w,$p, my_("Template could not be opened."), FALSE);
}
// Changed - End [FE]

$cnt=0;
$ds->DbfTransactionStart();
while ($data = fgetcsv ($fp, 4098, FIELDS_TERMINATED_BY)) {
   $cnt++;
   insert($w,textbr());
   insert($w,text(my_("Importing row:")." $cnt "));
   $num = count ($data);

   // blank row
   if (empty($data[0])) {
      insert($w,block("<b>".my_("Row is blank - ignoring")."</b>"));
      continue;
   }
   // bogus row
   if ($num<3) {
      insert($w, text(sprintf(my_("Row %u of imported file is not the correct format [ %s ]"), $cnt, $data[0])));
      break;
   }

   $ipaddr=trim($data[0]);
   $base=trim($data[0]);
   $descrip=$data[1];

   $size=trim($data[2]);
   if ( !is_numeric($size) )
	$size = getNetmask($size);
   $descrip=substr(trim($descrip),0,80);

   // Changed - Begin [FE]
   // Start of template support for base
   $info="";
   if ($template->is_error() == FALSE) {
        // all columns over 3 are considered for adding to template fields
        $position=4;
        $userfld=array();
        foreach($template->userfld as $key=>$value) {
            // set fields in template only if field in import file exists, else make blank
            $userfld[$key]=isset($data[$position]) ? $data[$position] : "";
            $position++;
        }
        $template->Merge($userfld);
        $err=$template->Verify($w);
        if ($err) {
            // ok to save what has been imported already
            $ds->DbfTransactionEnd();
            myError($w,$p, my_("Row failed template verify."));
        }

        if ($template->is_blank() == FALSE) {
            $info=$template->encode();
			// myError($w,$p, my_("info: $info"));
        }
    }
	 // Changed - End [FE]

   if (strlen($descrip) == 0) {
      insert($w, text(my_("No description for the subnet")));
      break;
   }
   else if (!$ipaddr) {
      insert($w, text(my_("IP address may not be blank")));
      break;
   }
   else if (testIP($ipaddr)) {
      insert($w, text(sprintf(my_("Invalid IP address [ %s ]"), $ipaddr)));
      break;
   }
   else if (!$size) {
      insert($w, text(my_("Subnet mask is invalid")));
      break;
   }
   else {
       // handle duplicate subnets
       $result=$ds->GetDuplicateSubnet($base, $size, $cust);
       if ( count($result) ) {
           $row = $result[0];
           // check if baseaddr and size match EXACTLY
           if ($row["baseaddr"] != $base or $row["subnetsize"] != $size) {
               insert($w, text(sprintf(my_("Subnet could not be updated - start address and size do not EXACTLY match existing subnet [ %s ]"), $ipaddr)));
               break;
           }

           insert($w,block("<b>".sprintf(my_("Row is duplicate - updating with [ %s, %s ]"), $ipaddr, $descrip)."</b>"));

           $result=&$ds->ds->Execute("UPDATE base
                   SET descrip=".$ds->ds->QMagic($descrip).",
                   lastmod=".$ds->ds->DBTimeStamp(time()).",
                   userid=".$ds->ds->QMagic(getAuthUsername()).",
                   admingrp=".$ds->ds->QMagic($admingrp)."
                   WHERE customer=$cust AND
                   baseaddr=".$ds->ds->QMagic($base));

           // Changed - Begin [FE]
           // Start of template support for base [FE]
           if (!empty($info)) {
               // Get the last insert_id
               $baseindex = $ds->ds->GetOne("SELECT baseindex 
                       FROM base
                       WHERE baseaddr=".$ds->ds->QMagic($base)." AND customer=$cust");

               // First, try to insert.
               $result = &$ds->ds->Execute("INSERT INTO baseadd
                       (info, baseindex)
                       VALUES
                       (".$ds->ds->QMagic($info).",
                        $baseindex)");
               // Second, try to update.
               if ( $result == FALSE ) {
                   $result=&$ds->ds->Execute("UPDATE baseadd
                           SET info=".$ds->ds->QMagic($info)."                                 
                           WHERE baseindex=$baseindex");

                   if ( $result == FALSE ) {
                       insert($w,block("<b>".my_("Error inserting/updating info.")."</b>"));
                   }   
               }
           }
           // End of template support for base
           // Changed - End [FE]

           $ds->AuditLog(sprintf(my_("User %s modified subnet details %s size %u customer cust %u"),
                       getAuthUsername(), $base, $size, $cust));

       }
       else {
           // if not duplicate, fall through to here
           if ($size > 1) {
               if (TestBaseAddr( $ipaddr, $size)) {
                   insert($w, text(my_("Invalid base address!")));
                   break;
               }
           }

           // use the first group user belongs to create subnet
           if ($baseindex = $ds->CreateSubnet($base, $size, $descrip, $cust, 0, $admingrp)) {
               $ds->AuditLog(sprintf(my_("User %s created new subnet %s size %u cust %u"),
                           getAuthUsername(), $base,
                           $size, $cust));

               // Changed - Begin [FE]
               // Start of template support for base
               if (!empty($info)) {
                   // First, try to insert.
                   $result = &$ds->ds->Execute("INSERT INTO baseadd
                           (info, baseindex)
                           VALUES
                           (".$ds->ds->QMagic($info).",
                            $baseindex)");
                   // Second, try to update.
                   if ( $result == FALSE ) {
                       $result=&$ds->ds->Execute("UPDATE baseadd
                               SET info=".$ds->ds->QMagic($info)."                                 
                               WHERE baseindex=$baseindex");

                       if ( $result == FALSE ) {
                           insert($w,block("<b>".my_("Error inserting/updating info.")."</b>"));
                       }   
                   }
               }
               // End of template support for base
               // Changed - End [FE]

           }
           else {
               insert($w, text(my_("Subnet could not be created")));
               break;
           }

       }
   }
}
// commit whatever has already been written
$ds->DbfTransactionEnd();

fclose ($fp);
printhtml($p);

?>
