<?php

// IPplan v6.00-BETA2
// Aug 24, 2001
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
//

require_once("../ipplanlib.php");
require_once("/usr/share/php/modules/adodb/adodb.inc.php");
require_once("../class.dbflib.php");
require_once("../layout/class.layout");
require_once("../auth.php");
require_once("dbschema.php");

$auth = new BasicAuthenticator(ADMINREALM, REALMERROR);

$auth->addUser(ADMINUSER, ADMINPASSWD);

// And now perform the authentication
$auth->authenticate();

// set language
isset($_COOKIE["ipplanLanguage"]) && myLanguage($_COOKIE['ipplanLanguage']);

// explicitly cast variables as security measure against SQL injection
list($dbtype, $dbhost, $dbname, $dbuser, $dbpass) = myRegister("S:dbtype S:dbhost S:dbname S:dbuser S:dbpassword");

$formerror = "";

$title = "IPPlan IPv6 Migration";
newhtml($p);
$w = myheading($p,$title,true);

$ds = &ADONewConnection($dbtype);
if (!$ds) {
  myError($w,$p, "Invalid database driver selected: ".$ds->ErrorMsg());
}
if(!$ds->Connect($dbhost, $dbuser, $dbpass, $dbname)) {
  myError($w,$p, "Failed to connect to the database: ".$ds->ErrorMsg());
}

$ds2 = &ADONewConnection(DBF_TYPE);
if (!$ds2) {
  myError($w,$p, "Invalid database driver selected: ".$ds2->ErrorMsg());
}
if(!$ds2->NConnect(DBF_HOST, DBF_USER, DBF_PASSWORD, DBF_NAME)) {
  myError($w,$p, "Failed to connect to the database: ".$ds2->ErrorMsg());
}

$tables_to_migrate = array("area"=>array("areaaddr"),
                           "base"=>array("baseaddr","subnetsize"),
                           "ipaddr"=>array("ipaddr"),
                           "ipaddradd"=>array("ipaddr"),
                           "ipaddrlnk"=>array("ipaddr","dstipaddr"),
                           "netrange"=>array("rangeaddr","rangesize"),
                           "bounds"=>array("boundsaddr","boundssize"),
                           "zones"=>array("zoneip","zonesize"),
                          );

foreach ($tables as $mtable => $mfield) {
  if ( $mtable == "auditlog" or $mtable == "version" ) continue;
  $fields = array();
  foreach ($tables[$mtable] as $data) {
	$fields[] = $data[0];
  }

  if ( isset($tables_to_migrate[$mtable]) )
	insert($w,textbr("Changing table '$mtable' fields: ".implode(",",$tables_to_migrate[$mtable])));
  else
	insert($w,textbr("Copying table '$mtable'"));

  $result = &$ds->Execute("SELECT ".implode(",",$fields)." FROM $mtable;");
  while ( $row = $result->FetchRow() ) {

//Changing what needs to be changed
	if ( isset($tables_to_migrate[$mtable]) ) {
	  $short = $tables_to_migrate[$mtable];
	  for ($i=0; $i < count($short);$i++) {
		if ($i == 0) {
		  $row[ $short[$i] ] = inet_ntoa( $row[ $short[$i] ] );
        } else if ( $mtable == "ipaddrlnk" and $i == 1 ) {
		  $row[ $short[$i] ] = inet_ntoa( $row[ $short[$i] ] );
		} else if ($i == 1) {
		  $row[ $short[$i] ] = inet_bits( $row[ $short[$i] ] );
		}
	  }
	}
//End changing

	$tvalues = array(); $cnt_fields = count($fields);
	for ($i=0; $i < $cnt_fields; $i++) {
	  if ( $tables[$mtable][$i][1] == "C" )
		$tvalues[] = $ds->qstr($row[ $fields[$i] ]);
	  elseif ( $tables[$mtable][$i][1] == "T" or $tables[$mtable][$i][1] == "D" )
		$tvalues[] = $ds->DBTimeStamp($row[ $fields[$i] ]);
	  else
		$tvalues[] = $row[ $fields[$i] ];
	}
	#insert($w,textbr("INSERT INTO $mtable (".implode(",",$fields).") VALUES (".implode(",",$tvalues).")"));
	$result2 = $ds2->Execute("INSERT INTO $mtable (".implode(",",$fields).") VALUES (".implode(",",$tvalues).")");
  }
}

printhtml($p);

?>