<?php

// IPplan v6.00-BETA2
// Aug 24, 2001
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
//

require_once("../ipplanlib.php");
require_once("/usr/share/php/modules/adodb/adodb.inc.php");
require_once("../class.dbflib.php");
require_once("../layout/class.layout");
require_once("../auth.php");
require_once("../class.xptlib.php");
require_once("../IPv4.php");

$auth = new SQLAuthenticator(REALM, REALMERROR);

// And now perform the authentication
$grps=$auth->authenticate();

// set language
isset($_COOKIE["ipplanLanguage"]) && myLanguage($_COOKIE['ipplanLanguage']);

//IPv4 class
$ipv4 = new Net_IPv4;

$title=my_("Results of your search");
newhtml($p);
$w=myheading($p, $title, true);

// explicitly cast variables as security measure against SQL injection
list( $ipaddr, $block ) = myRegister("S:ipaddr I:block");

if (!$_GET) {
   myError($w,$p, my_("You cannot reload or bookmark this page!"));
}

insert($w,heading(3, sprintf(my_("Search for all IP subnets which match '%s' for all customers"), $ipaddr)));

// basic sequence is connect, search, interpret search
// result, close connection
$ds=new IPplanDbf() or myError($w,$p, my_("Could not connect to database"));

// getting customers info for pretty print
$result = &$ds->GetCustomer();
while ( $row = $result->FetchRow() ) {
  $cust[ $row["customer"] ] = $row["custdescrip"];
}

$where = "";
if (DBF_TYPE=="mysql" or DBF_TYPE=="maxsql")
  $where = "WHERE baseaddr RLIKE ".$ds->ds->QMagic($ipaddr);
else if (DBF_TYPE=="postgres7")
  $where = "WHERE baseaddr ~ ".$ds->ds->QMagic($ipaddr);
else
  $where = "WHERE baseaddr LIKE ".$ds->ds->QMagic("%".$ipaddr."%");

//Getting the IP details
$result = &$ds->ds->Execute("SELECT baseaddr, subnetsize, admingrp, customer,
                            userid, descrip, baseindex
						FROM base $where");

$totcnt = 0;
$vars = "";
// fastforward till first record if not first block of data
while ($block and $totcnt < $block*MAXTABLESIZE and $row = $result->FetchRow() ) {
    $vars=DisplayBlock($w, $row, $totcnt,"&ipaddr=$ipaddr");
    $totcnt++;
}

insert($w,$t = table(array("cols"=>"6",
                           "class"=>"outputtable")));

// draw heading
setdefault("cell",array("class"=>"heading"));
insert($t,$c = cell());
if (!empty($vars))
    insert($c,anchor($vars, "<<"));
insert($c,text(my_("Base address")));
insert($t,$c = cell());
insert($c,text(my_("Subnet mask")));
insert($t,$c = cell());
insert($c,text(my_("Description")));
insert($t,$c = cell());
insert($c,text(my_("Group")));
insert($t,$c = cell());
insert($c,text(my_("Customer")));
insert($t,$ck = cell());
insert($ck,text(my_("Changed by")));

$cnt=0;
while ( $row = $result->FetchRow() ) {
  setdefault("cell",array("class"=>color_flip_flop()));

  insert($t,$c = cell());
  if ( $ipv4->validateIP($row["baseaddr"]) )
	insert($c,anchor("../user/displaysubnet.php?baseindex=".$row["baseindex"],$row["baseaddr"]));
  else
	insert($c,anchor("../user/displaysubnet6.php?baseindex=".$row["baseindex"],$row["baseaddr"]));
  //insert($c, text($row["baseaddr"]));

  $netmask = inet_netmask($row["baseaddr"],$row["subnetsize"]);
  insert($t,$c = cell());
  insert($c, text( $netmask."/".$row["subnetsize"] ));

  insert($t,$c = cell());
  insert($c, text($row["descrip"]));

  insert($t,$c = cell());
  insert($c, text($row["admingrp"]));

  insert($t,$c = cell());
  insert($c, text($cust[ $row["customer"] ]));

  insert($t,$c = cell());
  insert($c, text($row["userid"]));

  if ($totcnt % MAXTABLESIZE == MAXTABLESIZE-1)
     break;
  $cnt++;
  $totcnt++;
}
insert($w,block("<p>"));

if (!$cnt) {
   myError($w,$p, my_("Search found no matching entries"));
}

$vars="";
$printed=0;
while ( $row=$result->FetchRow() ) {
	$totcnt++;
    $vars=DisplayBlock($w, $row, $totcnt,"&ipaddr=$ipaddr");
    if (!empty($vars) and !$printed) {
        insert($ck,anchor($vars, ">>"));
        $printed=1;
    }
}

printhtml($p);
?>