<?php

// IPplan v6.00-BETA2
// Aug 24, 2001
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
//

require_once("../ipplanlib.php");
require_once("/usr/share/php/modules/adodb/adodb.inc.php");
require_once("../class.dbflib.php");
require_once("../layout/class.layout");
require_once("../auth.php");
require_once("../class.xptlib.php");
require_once("../class.templib.php");

// first element of "Additional data" section of modifyipform page
// this changes as elements are added to the page
define("ADD_INFO", 10);

$auth = new SQLAuthenticator(REALM, REALMERROR);

// And now perform the authentication
$auth->authenticate();

// set language
isset($_COOKIE["ipplanLanguage"]) && myLanguage($_COOKIE['ipplanLanguage']);

//setdefault("window",array("bgcolor"=>"white"));
//setdefault("table",array("cellpadding"=>"0"));
//setdefault("text",array("size"=>"2"));

$title=my_("Create IP address entry");
newhtml($p);
$w=myheading($p, $title, true);

// explicitly cast variables as security measure against SQL injection
list($baseindex, $ipplanParanoid) = myRegister("I:baseindex I:ipplanParanoid");

if (!$_GET) {
   myError($w,$p, my_("You cannot reload or bookmark this page!"));
}

// basic sequence is connect, search, interpret search
// result, close connection

$ds=new IPplanDbf() or myError($w,$p, my_("Could not connect to database"));

$result=$ds->GetBaseFromIndex($baseindex);
if (!$row = $result->FetchRow()) {
    myError($w,$p, my_("Subnet cannot be found!"));
}
$cust = $row["customer"];

$md5str = $ds->GetMD5(0,$baseindex);

insert($w,block("<h3>"));
insert($w,text(my_("IP address details")));
insert($w,block("</h3>"));

// ------------------- request ip address section starts here ------------------------

requestip($p, $w, $ds, $cust);

// start form
insert($w, $f = form(array("name"=>"INSERT",
                           "method"=>"post",
                           "action"=>"displaysubnet6.php")));

myFocus($p, "INSERT", "ipaddr");
insert($f, $con=container("fieldset",array("class"=>"fieldset")));
insert($con, $legend=container("legend",array("class"=>"legend")));
insert($legend, text(my_("IPv6 information")));
insert($con,textbr(my_("IPv6 Address")));
insert($con,hidden(array("name"=>"md5str",
                      "value"=>"$md5str")));
insert($con,input_text(array("name"=>"ipaddr",
                           "size"=>"40",
                           "maxlength"=>"39")));

insert($con,textbrbr(my_("User")));
insert($con,input_text(array("name"=>"userinf",
                           "size"=>"80",
                           "maxlength"=>"80")));
insert($con,textbrbr(my_("Location")));
insert($con,input_text(array("name"=>"location",
                           "size"=>"80",
                           "maxlength"=>"80")));
insert($con,textbrbr(my_("Device description")));
insert($con,input_text(array("name"=>"descrip",
                           "size"=>"80",
                           "maxlength"=>"80")));
insert($con,textbrbr(my_("Record Type")));       
insert($con,selectbox(array("PTR"=>"PTR",
                          "CNAME"=>"CNAME", 
                          "AAAA"=>"AAAA"),
                          array("name"=>"recordtype"), $recordtype));
insert($con,textbrbr(my_("Device hostname")));
insert($con,input_text(array("name"=>"hname",
                           "size"=>"100",
                           "maxlength"=>"100")));
insert($con,textbrbr(my_("Telephone number")));
insert($con,input_text(array("name"=>"telno",
                           "size"=>"15",
                           "maxlength"=>"15")));
insert($con,textbrbr(my_("MAC address")));
insert($con,input_text(array("name"=>"macaddr",
                           "size"=>"12",
                           "maxlength"=>"12")));
// from the requestip - this will be the index to delete from the request
// table
insert($con,hidden(array("name"=>"request",
                      "value"=>"0")));

insert($con,hidden(array("name"=>"action",
                       "value"=>"insert")));
insert($con,hidden(array("name"=>"baseindex",
                       "value"=>$baseindex)));

insert($f,submit(array("value"=>my_("Submit"))));
insert($f,freset(array("value"=>my_("Clear"))));

printhtml($p);

function jsAddSlashes($str) {
   $pattern = array(
       "/\"/"    ,
       "/\'/"    , "/&/"    , "/</"    , "/>/"
   );
   $replace = array(
       "\\\""    ,
       "\\'"    , "\\x26"  , "\\x3C"  , "\\x3E"
   );
   return preg_replace($pattern, $replace, $str);
}

function requestip(&$p, &$w, $ds, $cust) {

    // get all request records
    $sqllastmod = $ds->ds->SQLDate("M d Y H:i:s", 'lastmod');
    $result=$ds->ds->Execute("SELECT requestindex, requestdesc, userinf, location, telno,
                             descrip, hname, macaddr, $sqllastmod AS lastmod, info
                           FROM requestip
                           WHERE customer=$cust");

    // emulate for databases that do not have RecordCount
    // not records, do nothing
    if (!$result->PO_RecordCount("requestip", "customer=$cust")) {
        return;
    }

    // if a specific network template exists, use that, else use generic template
    $savtemplate=new IPplanIPTemplate("iptemplate", $cust);
    $err=$savtemplate->is_error();

    $lst=array();
    $jsarr="";
    $lst["0"]="No request";
    $cnt=0;
    while($row=$result->FetchRow()) {
        $template=$savtemplate;  // reset template - additional fields could have been added
        $col=$row["requestindex"];
        $lst["$col"]=$row["requestdesc"];

        $jsarr.="    dbf[$col]=new Array();\n";
        $jsarr.="    dbf[$col][1]=\"".jsAddSlashes($row["userinf"])."\";\n";
        $jsarr.="    dbf[$col][2]=\"".jsAddSlashes($row["location"])."\";\n";
        $jsarr.="    dbf[$col][3]=\"".jsAddSlashes($row["descrip"])."\";\n";
        $jsarr.="    dbf[$col][4]=\"".jsAddSlashes($row["hname"])."\";\n";
        $jsarr.="    dbf[$col][5]=\"".jsAddSlashes($row["telno"])."\";\n";
        $jsarr.="    dbf[$col][6]=\"".jsAddSlashes(substr(chunk_split($row["macaddr"], 2, ':'), 0, -1))."\";\n";

        // no template error
        if (!$err) {
            $template->Update($template->decode($row["info"]));
            $cnt2=ADD_INFO;
            $jsset="";
            foreach($template->userfld as $arr) {
#                $jsarr.="    dbf[$col][$cnt2]=\"".jsAddSlashes(preg_replace('/(\r\n)|\n|\r/m', '\n',
#                    isset($arr["value"]) ? $arr["value"] : "" ))."\";\n";
#                $jsset.="    parent.document.INSERT.elements[$cnt2].value=dbf[idx][$cnt2];\n";

                $cnt2++;
            }
        }

        $cnt++;
    }

    insert($p, script('
function modifyipform() {

   dbf=new Array();
   '.$jsarr.'

   idx=document.REQUESTIP.request.value;
   document.INSERT.request.value=idx;

   if ((idx) == 0) return;

   document.INSERT.userinf.value=dbf[idx][1];
   document.INSERT.location.value=dbf[idx][2];
   document.INSERT.descrip.value=dbf[idx][3];
   document.INSERT.hname.value=dbf[idx][4];
   document.INSERT.telno.value=dbf[idx][5];
   document.INSERT.macaddr.value=dbf[idx][6];
   '.$jsset.'

} ', array("language"=>"JavaScript", "type"=>"text/javascript")));

    insert($w, $fr = form(array("name"=>"REQUESTIP",
                    "method"=>"get",
                    "action"=>$_SERVER["PHP_SELF"])));
    insert($fr, $conr=container("fieldset",array("class"=>"fieldset")));
    insert($conr, $legend=container("legend",array("class"=>"legend")));
    insert($legend, text(my_("Requested addresses")));

    insert($conr,selectbox($lst,
                array("name"=>"request", "onChange"=>"modifyipform()")));
}

// ------------------- request ip address section ends here ------------------------

?>
