<?php

// IPplan v6.00-BETA2
// Aug 24, 2001
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
//

require_once("../ipplanlib.php");
require_once("/usr/share/php/modules/adodb/adodb.inc.php");
require_once("../class.dbflib.php");
require_once("../layout/class.layout");
require_once("../auth.php");
require_once("../IPv4.php");
require_once("../IPv6.php");

// display overlaps between two customers - does the entire table
function searchOverlap($ds, &$w, $cust1, $cust2) {

   global $block;

   // dont trust variables
   $cust1=floor($cust1);
   $cust2=floor($cust2);
   $custdescrip1=$ds->GetCustomerDescrip($cust1);
   $custdescrip2=$ds->GetCustomerDescrip($cust2);

   // this query is not quick as indexes cannot be used!!!
   // must have first baseaddr called baseaddr else block pager
   // will not work - may break databases other than mysql
/*old
   $result=&$ds->ds->Execute("SELECT t1.baseaddr AS baseaddr,
                           t1.baseindex AS baseindex1,
                           t1.subnetsize AS subnetsize1,
                           t1.descrip AS descrip1,
                           t2.baseaddr AS baseaddr2,
                           t2.baseindex AS baseindex2,
                           t2.subnetsize AS subnetsize2,
                           t2.descrip AS descrip2
                        FROM base t1, base t2
                        WHERE ((t1.baseaddr BETWEEN t2.baseaddr AND
                                t2.baseaddr+t2.subnetsize-1) OR
                               (t1.baseaddr+t1.subnetsize-1
                                BETWEEN t2.baseaddr AND
                                        t2.baseaddr+t2.subnetsize-1) OR
                               (t1.baseaddr < t2.baseaddr AND
                                t1.baseaddr+t1.subnetsize >
                                t2.baseaddr+t2.subnetsize)) AND
                               t1.customer=$cust1 AND
                                t2.customer=$cust2
                        ORDER BY t1.baseaddr");
*/
   $result=&$ds->ds->Execute("SELECT t1.baseaddr AS baseaddr,
                           t1.baseindex AS baseindex1,
                           t1.subnetsize AS subnetsize1,
                           t1.descrip AS descrip1,
                           t2.baseaddr AS baseaddr2,
                           t2.baseindex AS baseindex2,
                           t2.subnetsize AS subnetsize2,
                           t2.descrip AS descrip2
                        FROM base t1, base t2
                        WHERE   t1.customer=$cust1 AND
                                t2.customer=$cust2");

  $overlap = array();
  $i = 0;
  while ( $row = $result->FetchRow() ) {
	$iptype = Net_IPv4::validateIP($row["baseaddr"]) ? 1 : 2;
	$iptype2 = Net_IPv4::validateIP($row["baseaddr2"]) ? 1 : 2;
	$bool = false; $bool2 = false;
	if ( $iptype == 1 and $iptype2 == 1 ) {
	  $bool = Net_IPv4::ipInNetwork($row["baseaddr"],$row["baseaddr2"]."/".$row["subnetsize2"]);
	  $bool2 = Net_IPv4::ipInNetwork($row["baseaddr2"],$row["baseaddr"]."/".$row["subnetsize1"]);
	} elseif ( $iptype == 2 and $iptype2 == 2 ) {
	  $bool = Net_IPv6::isInNetmask($row["baseaddr"],$row["baseaddr2"],$row["subnetsize2"]);
	  $bool2 = Net_IPv6::isInNetmask($row["baseaddr2"],$row["baseaddr"],$row["subnetsize1"]);
	}
	if ( $bool or $bool2 ) {
	  $overlap[$i] = $row;
      $overlap[$i]["iptype"] = $iptype;
      $i++;
	}
  }

   mysort(&$overlap,"baseaddr");
   $totcnt=0; $cnt_overlap = count($overlap);
   $vars="";
   // fastforward till first record if not first block of data
   while ($block and $totcnt < $block*MAXTABLESIZE and
          $totcnt < $cnt_overlap ) {
       $vars=DisplayBlock($w, $overlap[$totcnt], $totcnt,
                            "&cust1[]=".$cust1.
                            "&cust2[]=".$cust2);
       $totcnt++;
   }
   insert($w,block("<p>"));

   $cnt=0;
   for ($i=$totcnt; $i < $cnt_overlap; $i++) {
	$row = $overlap[$i];
	$iptype = $row["iptype"];

      // draw heading only if there are records to display
      if ($cnt==0) {
         // create a table
         insert($w,$t = table(array("cols"=>"8",
                                 "class"=>"outputtable")));
         // draw heading
         setdefault("cell",array("class"=>"heading"));
         insert($t,$c = cell(array("colspan"=>"4")));
         insert($c,block("<center>"));
         insert($c,text($custdescrip1));
         insert($c,block("</center>"));
         insert($t,$c = cell(array("colspan"=>"4")));
         insert($c,block("<center>"));
         insert($c,text($custdescrip2));
         insert($c,block("</center>"));

         insert($t,$c = cell());
         if (!empty($vars))
            insert($c,anchor($vars, "<<"));
         insert($c,text(my_("Base address")));
         insert($t,$c = cell());
         insert($c,text(my_("Subnet size")));
         insert($t,$c = cell());
         insert($c,text(my_("Subnet mask")));
         insert($t,$c = cell());
         insert($c,text(my_("Description")));

         insert($t,$c = cell());
         insert($c,text(my_("Base address")));
         insert($t,$c = cell());
         insert($c,text(my_("Subnet size")));
         insert($t,$c = cell());
         insert($c,text(my_("Subnet mask")));
         insert($t,$ck = cell());
         insert($ck,text(my_("Description")));

         setdefault("cell",array("class"=>color_flip_flop()));
      }

      // customer 1
      if ($row["subnetsize1"] == 1) {
          insert($t,$c = cell());
          insert($c,text($row["baseaddr"]));
      }
      else {
          insert($t,$c = cell());
		  if ( $iptype == 1 )
			insert($c,anchor("displaysubnet.php?baseindex=".$row["baseindex1"],
                           $row["baseaddr"]));
		  else
			insert($c,anchor("displaysubnet6.php?baseindex=".$row["baseindex1"],
                           $row["baseaddr"]));			
      }

      if ( ($iptype == 1 and $row["subnetsize1"] == 32) or ($iptype == 2 and $row["subnetsize1"] == 128) ) {
          insert($t,$c = cell());
          insert($c,text("Host"));
      }
      else {
          insert($t,$c = cell());
		  if ( $iptype == 1 )
			insert($c,text( pow(2,32 - $row["subnetsize1"]) ));
		  else
			insert($c,text("2 ^ ".$row["subnetsize1"]));
      }

      insert($t,$c = cell());
      insert($c,text(inet_netmask($row["baseaddr"],$row["subnetsize1"])."/".$row["subnetsize1"]));

      insert($t,$c = cell());
      insert($c,text($row["descrip1"]));

      // customer 2
      if ($row["subnetsize2"] == 1) {
          insert($t,$c = cell());
          insert($c,text($row["baseaddr2"]));
      }
      else {
          insert($t,$c = cell());
		  if ( $iptype == 1 )
			insert($c,anchor("displaysubnet.php?baseindex=".$row["baseindex2"],
                           $row["baseaddr2"]));
		  else
			insert($c,anchor("displaysubnet6.php?baseindex=".$row["baseindex2"],
                           $row["baseaddr2"]));	
      }

      if ( ($iptype == 1 and $row["subnetsize2"] == 32) or ($iptype == 2 and $row["subnetsize2"] == 128) ) {
          insert($t,$c = cell());
          insert($c,text(my_("Host")));
      }
      else {
          insert($t,$c = cell());
		  if ( $iptype == 1 )
			insert($c,text( pow(2,32 - $row["subnetsize2"]) ));
		  else
			insert($c,text("2 ^ ".$row["subnetsize2"]));
      }

      insert($t,$c = cell());
      insert($c,text(inet_netmask($row["baseaddr2"],$row["subnetsize2"])."/".$row["subnetsize2"]));

      insert($t,$c = cell());
      insert($c,text($row["descrip2"]));

      if ($totcnt % MAXTABLESIZE == MAXTABLESIZE-1)
         break;
      $cnt++;
      $totcnt++;
   }
   insert($w,block("<p>"));

   if ($cnt) {
       $vars="";
       $printed=0;
       $totcnt++;
       while ($totcnt < $cnt_overlap ) {
           $vars=DisplayBlock($w, $overlap[$cnt], $totcnt,
                   "&cust1[]=".$cust1.
                   "&cust2[]=".$cust2);
           if (!empty($vars) and !$printed) {
               insert($ck,anchor($vars, ">>"));
               $printed=1;
           }
           $totcnt++;
       }
   }

}



$auth = new SQLAuthenticator(REALM, REALMERROR);

// And now perform the authentication
$auth->authenticate();

// set language
isset($_COOKIE["ipplanLanguage"]) && myLanguage($_COOKIE['ipplanLanguage']);

//setdefault("window",array("bgcolor"=>"white"));
//setdefault("table",array("cellpadding"=>"0"));
//setdefault("text",array("size"=>"2"));

$title=my_("Results of your search");
newhtml($p);
$w=myheading($p, $title, true);

// explicitly cast variables as security measure against SQL injection
list($cust1, $cust2, $block) = myRegister("A:cust1 A:cust2 I:block");

// could be array!
//$cust1=floor($cust1);
//$cust2=floor($cust2);
if (!$_GET) {
   myError($w,$p, my_("You cannot reload or bookmark this page!"));
}

// basic sequence is connect, search, interpret search
// result, close connection
$ds=new IPplanDbf() or myError($w,$p, my_("Could not connect to database"));

insert($w,heading(3, my_("Search for overlapping subnets between customers/autonomous systems")));

// reduce the two arrays to a single array, removing all duplicates
$arr=array_unique(array_merge($cust1, $cust2));
sort($arr);

if (count($arr) <= 1) {
   myError($w,$p, my_("Both customers selected are the same - all subnets will overlap!"));
}

// Loop through the list of customers doing an overlap search between
// the current customer and all of the following customers.

foreach ($arr as $ind1 => $id1) {
   foreach ($arr as $ind2 => $id2) {
      if ($id2 <= $id1) {
         continue;
      }
      searchOverlap($ds, $w, $id1, $id2);
   }
}

printhtml($p);

?>
